%%%%%%%%%%%%%%%%% Example 10.2 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Pole placement by full-state feedback ----
%
clear
disp('Example 10.2')

Ts = 0.1
A = [0.81   -0.23   -0.045    % state matrix
     0.09    0.98   -0.0023
     0.005   0.10    1     ]
B = [0.09 0.0047 0.00016]'    % input matrix
p = [0.75 0.8 0.9]'           % desired pole locations
F = place(A,B,p)              % control gain
A_cl = A-B*F                  % closed-loop system matrix
diff = sort(p)- sort(eig(A_cl))  % check closed-loop eigenvalues
norm(F)
%%%%%%%%%%
