%%%%%%%%%% Reinforcement Problem 10.10 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Third-order system ----
%
clear
disp('Reinforcement Problem 10.10')

Ts = 0.1
A = [ 0.8238     0.0400     0.0810
      0.0459     0.7799     0.1161
      0.0781     0.0020     0.7448]
C = [0 1 0]
B = [0; 0; 0]
D = 0
p = [0.3 0.4 0.6]'
L = place(A',C',p)'
A_ob = A-L*C
eig(A_ob)

x0 = [1 0.5 -0.25]'   % initial condition
time = [0:Ts:6]';
u = zeros(1,length(time));
G = ss(A,B,C,D,Ts)
[y,t,x] = lsim(G,u,time,x0);
G_ob = ss(A_ob,L,C,D,Ts)
[y_hat,t,x_hat] = lsim(G_ob,y,time);

figure
plot(time,x,'o',time,x_hat,'+');grid
xlabel('Time (s)')
text(4,2.1,'o ==> x')
text(4,1.9,'+ ==> x\_hat')
title('State responses for Reinforcement Problem 10.10')

figure
plot(time,y,'o',time,y_hat,'+');grid
xlabel('Time (s)')
text(4.1,0.41,'o ==> y')
text(4.1,0.38,'+ ==> y\_hat')
title('Output responses for Reinforcement Problem 10.10')
%%%%%%%%%%