%%%%%%%%%%%%%%%%% Example 2.11 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Zero outside the unit circle ----
%
clear
disp('Example 2.11')
% create TF object with Ts = 0.1 s
G = tf([-0.3354  0.3526],[1  -1.724  0.7408],0.1)
[zG,pG,kG] = zpkdata(G,'v')
figure
ucircle, axis equal, hold on   % draw unit circle and set axes
pzmap(G), hold off             % plot poles and zero in z-plane
title('Example 2.11')
set_xo_size                    % show larger X's and O's
disp('Plotting pole-zero locations')
disp('******>'), pause 

[y,k] = step(G);               % compute step response of G(z)
figure
stem(k,y,'filled',':'),grid    % plot step response
title('Step response for Example 2.11')
xlabel('Time (s)')
disp('Plotting step response')
%%%%%%%%%%