%%%%%%%%%%%%%%%%%% Example 2.8 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---- Response to a piecewise-constant input ----
%
clear
disp('Example 2.8')
numG = [2 -2.2 0.56];                  % numerator of G(z)
denG = [1 -0.6728 0.0463 0.486];       % denominator of G(z)
Ts = 0.2                               % sampling period
G = tf(numG,denG,Ts)                   % create TF object G(z)
dtime = [0:Ts:8]';                     % discrete time samples
u = 2.0*ones(size(dtime));             % start with all input values = 2.0
ii = find(dtime>=2.0);                 % use find cmd to get indices of
u(ii) = 0.5;                           % ...elements to be changed
y = lsim(G,u,dtime);                   % compute response due to input u
figure
stem(dtime,y,'filled'),grid            % plot response of G(z) due to u
hold on
plot(dtime,u,'o')                      % plot input
hold off
text(2.3,-1.8,'output')                % add labels to plot
text(1.6,2.3,'input')
title('Example 2.8')
xlabel('Time (s)')
%%%%%%%%%%