%%%%%%%%%%%%%%%%%% Example 3.1 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Series connection of two systems ----
%
% revised 05Jan02 JHC - eliminate k 
clear
disp('Example 3.1')
Ts = 1;
G1 = tf(0.02*[2 1.4],[1 -1.7 0.72],Ts)   % G1 in TF form
[zG1,pG1,kG1] = zpkdata(G1,'v')          % zeros, poles, & gain of G1
disp('******>'), pause 

pp = 0.9*exp(j*pi/5);
pG2 = [pp; conj(pp); -0.8]         % poles of G2 as column vector
G2 = zpk(-0.2,pG2,0.5,Ts)          % G2 in ZPK form
disp('******>'), pause 

Tzpk = G2*G1                       % series combination in ZPK form
[zT,pT,kT] = zpkdata(Tzpk,'v')     % zeros, poles, & gain from ZPK form
disp('******>'), pause 

xy2p(pT);                          % poles of T(z) in polar form
Ttf = tf(Tzpk)                     % series combination in TF form

dt=[0:Ts:50]';                     % discrete time sequence
yzpk = step(Tzpk,dt);              % step response from ZPK form
ytf  = step(Ttf,dt);               % step response from TF form

figure
stem(dt,yzpk,':','o'); grid        % plot ZPK response
hold on
plot(dt,ytf,'+');                  % plot TF form over it
hold off                           % step response of T(z) from TF form
title('Impulse responses for Example 3.1')
text(4.0,3.3,'O ==> ZPK form')
text(4.0,3.1,'+ ==> TF form')
xlabel('Time (s)')
%%%%%%%%%%
