%%%%%%%%%%%%%%%%%% Example 3.3 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Series/parallel connections ----
%
clear
disp('Example 3.3')
Ts = 1;                                 % unity sampling period
G1 = tf(0.02*[2 1.4],[1 -1.7 0.72],Ts)  % G1(z) in TF form
disp('******>'), pause 
pp = 0.9*exp(j*pi/5);
pG2 = [pp; conj(pp); -0.8];             % poles of G2 as column vector
G2 = zpk(-0.2,pG2,0.5,Ts)               % G2 in ZPK form
disp('******>'), pause 
G3 = tf([1 0.5],[1 0.75],Ts)            % G3 in TF form
disp('******>'), pause 
denG4 = conv([1 -0.9],conv([1 -0.8],[1 0.8]));   % denom of G4
G4 = tf([0.15 0],denG4,Ts)              % G4 in TF form
disp('******>'), pause 

%---- connect the 4 blocks --------------
T = G4*(G3+G2*G1)                       % overall T(z) in ZPK form
disp('******>'), pause 
[zG1,pG1,kG1] = zpkdata(G1,'v')
[zG2,pG2,kG2] = zpkdata(G2,'v')
disp('******>'), pause 
xy2p(pG2);                              % poles of G2 in polar form
disp('******>'), pause 
[zG3,pG3,kG3] = zpkdata(G3,'v')
[zG4,pG4,kG4] = zpkdata(G4,'v')
disp('******>'), pause 
[zT,pT,kT] = zpkdata(T,'v')             % zeros, poles, gain of T(z)
disp('******>'), pause 
disp('zeros of Tz')
xy2p(zT);                               % zeros of T(z) in polar form
disp('poles of Tz')
xy2p(pT);                               % poles of T(z) in polar form
[resp,k] = step(T);                     % step resp. of T(z)


figure
plot(k,resp,'+'); grid                  % plot response
title('Step response for Example 3.3')
xlabel('Time (s)')
disp(['DC gain = ', num2str(dcgain(T))])% steady-state step response
%%%%%%%%%%