%%%%%%%%%% Reinforcement Problem 3.17 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  ---- Gain variation for second-order system ----
%
clear
disp('Reinforcement Problem 3.17')
Ts = 1;
%---- H(z) & denG are same for each case
H = 1;      		            % unity feedback
denG = conv([2 0.1],[1 -0.3]);  % forward transfer function
dtime = 0:Ts:10;

K = [0.1 0.3 0.6 1];	        % gains for numG
%-------- run 4 cases, plotting step responses as subplots ----
figure
for ii = 1:4,
  kG = K(ii)
  G = tf(kG*[3 0.1],denG,Ts)    % forward transfer function 
  T = feedback(G,H)             % closed-loop system
  y = step(T,dtime);            % compute step response
  subplot(2,2,ii)
  stem(dtime,y,':','filled');grid     % plot step response
  title(['Reinf 3.17: K = ',num2str(kG)])
end

%----- rerun the 4 cases, plotting CL poles in z plane -----
figure
ucircle;grid
hold on
for ii = 1:4,
  kG = K(ii);
  disp(['==== K = ',num2str(kG),' ===='])
  G = tf(kG*[3 0.1],denG,Ts);    % forward transfer function
  T = feedback(G,H);             % closed-loop system
  [zT,pT,kT] = zpkdata(T,'v')    % CL zeros,poles,gain
  plot(real(pT),imag(pT),'*')
  title(['K = ',num2str(kG)])
end
hold off
title('Pole-zero plot for Reinforcement Problem 3.17')
xlabel('Real part of z')
ylabel('Imaginary part of z')
%%%%%%%%%%
