%%%%%%%%%%% Reinforcement Problem 3.2 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%    ---- Third- and first-order systems ----
%
clear
disp('Reinforcement Problem 3.2')
Ts = 1;
pp1 = [-0.1; roots([1 -0.4 0.29])];
G1 = zpk([0.4],pp1,3,Ts)           % G1 in ZPK form
G2 = tf(4,[1 -0.8],Ts)             % G2 in TF form
T = G2*G1                          % series combination in ZPK form
k = [0:Ts:30];                     % discrete time sequence
y = step(T,k);                     % step response 
figure
stem(k,y,':','filled'); grid   % plot step response
title('Step response for Reinforcement Problem 3.2')
xlabel('Discrete time k')

%----- compute poles & zeros of G1, G2, & T ----
[zG1,pG1,kG1] = zpkdata(G1,'v');    % zeros, poles, & gain of G1
[zG2,pG2,kG2] = zpkdata(G2,'v');    % zeros, poles, & gain of G1
[zT,pT,kT] = zpkdata(T,'v');        % zeros, poles, & gain from ZPK form
%---- display all zeros in polar form
[magzG1,thetazG1] = xy2p(zG1)
[magzG2,thetazG2] = xy2p(zG2)
[magzT,thetazT] = xy2p(zT)
%---- display all poles in polar form
[magpG1,thetapG1] = xy2p(pG1)
[magpG2,thetapG2] = xy2p(pG2)
[magpT,thetapT] = xy2p(pT)
%%%%%%%%%%