%%%%%%%%%%% Comprehensive Problem 5.6 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Hydro-turbine System

clear 
disp('Comprehensive Problem 5.6')
disp('Discretization at a lower frequency')

dhydro  % read data
disp('*****>'), pause

disp('Discretization at 10 Hz')
Gz10 = c2d(Gs,1/10)
disp('*****>'), pause

disp('Comparison of discretized system at 10 Hz and continuous-time system')
disp('1st column is 10 Hz, 2nd column is continuous-time system')
disp('Poles of open-loop system')
[pole(Gz10) pole(Gs)]
disp('the poles are related by z = exp(pole*Ts)')
disp(' ')
disp('*****>'), pause

disp('Zeros of open-loop system')
[tzero(Gz10) tzero(Gs)]
disp('Zeros in right half-plane of continuous-time systems mapped into')
disp('  zeros outside the unit cicle of discrete-time systems.')
disp('There is no simple relationship between the zeros')
disp(' ')
disp('*****>'), pause

disp('DC gain of open-loop system')
[dcgain(Gz10) dcgain(Gs)]
disp('Discretization does not change DC gain')
disp('*****>'), pause

disp('End of Comprehensive Problem 5.6')
%%%%%%%%%%