function ucircle(npts)
%UCIRCLE  Draws the unit circle
%
%   UCIRCLE draws the unit circle, using 90 points, and set 
%   x/y axis to be of equal size
%
%   UCIRCLE(NPTS) draws the unit circle, using NPTS points

%%%%%%%%%%%%%%%%%% ucircle.m %%%%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

const = 180/pi;
if nargin == 0,
	npts = 90;
end
deltheta = 360/npts;
theta = [0:deltheta:360]/const;
plot(sin(theta),cos(theta))
axis equal
%%%%%%%%%%
